package org.richfaces.component.events;

import org.richfaces.component.*;
import javax.faces.component.UIComponent;
import javax.faces.event.FacesEvent;
import javax.faces.event.FacesListener;

public class ScheduleItemResizedEvent extends FacesEvent {

    private String eventId;
    private int dayDelta;
    private int minuteDelta;

    public ScheduleItemResizedEvent(UIComponent component, String eventId, int dayDelta, int minuteDelta) {
        super(component);
        this.eventId = eventId;
        this.dayDelta = dayDelta;
        this.minuteDelta = minuteDelta;
    }

    public boolean isAppropriateListener(FacesListener facesListener) {
        return facesListener instanceof ScheduleListener;
    }

    public void processListener(FacesListener facesListener) {
        ((ScheduleListener) facesListener).eventResized(this);
    }

    public String getEventId() {
        return eventId;
    }

    public int getDayDelta() {
        return dayDelta;
    }

    public int getMinuteDelta() {
        return minuteDelta;
    }

    @Override
    public String toString() {
        return getClass().getSimpleName() + "[eventId=" + eventId + ";dayDelta=" + dayDelta + ";minuteDelta=" + minuteDelta + "]";
    }
}
