package org.richfaces.component.events;

import org.richfaces.component.*;
import javax.faces.component.UIComponent;
import javax.faces.event.FacesEvent;
import javax.faces.event.FacesListener;

public class ScheduleItemSelectedEvent extends FacesEvent {

    private String eventId;

    public ScheduleItemSelectedEvent(UIComponent component, String eventId) {
        super(component);
        this.eventId = eventId;
    }

    public boolean isAppropriateListener(FacesListener facesListener) {
        return facesListener instanceof ScheduleListener;
    }

    public void processListener(FacesListener facesListener) {
        ((ScheduleListener) facesListener).eventSelected(this);
    }

    public String getEventId() {
        return eventId;
    }

    @Override
    public String toString() {
        return getClass().getSimpleName() + "[eventId=" + eventId + "]";
    }
}
