package org.richfaces.component.events;

import java.util.Date;

import javax.faces.component.UIComponent;

import org.ajax4jsf.event.AjaxEvent;

public class ScheduleLoadEvent extends AjaxEvent {

    private Date startDate;
    private Date endDate;

    public ScheduleLoadEvent(UIComponent component, Date startDate, Date endDate) {
        super(component);
        this.startDate = startDate;
        this.endDate = endDate;
    }

    public Date getStartDate() {
        return startDate;
    }

    public Date getEndDate() {
        return endDate;
    }

    @Override
    public String toString() {
        return getClass().getSimpleName() + "[startDate=" + startDate + ";endDate=" + endDate + "]";
    }
}
