package org.richfaces.component.events;

import org.richfaces.component.*;
import javax.faces.component.UIComponent;
import javax.faces.event.FacesEvent;
import javax.faces.event.FacesListener;

public class ScheduleViewChangedEvent extends FacesEvent {

    private String view;

    public ScheduleViewChangedEvent(UIComponent component, String view) {
        super(component);
        this.view = view;
    }

    public boolean isAppropriateListener(FacesListener facesListener) {
        return facesListener instanceof ScheduleListener;
    }

    public void processListener(FacesListener facesListener) {
        ((ScheduleListener) facesListener).viewChanged(this);
    }

    public String getView() {
        return view;
    }

    @Override
    public String toString() {
        return getClass().getSimpleName() + "[view=" + view + "]";
    }
}
