window.RichFaces = window.RichFaces || {};

window.RichFaces.FullCalendar = (function() {
    var formatDateParam = function(date) {
        return Math.round(date.getTime() / 1000);
    }
	
    return function(id, options, loadItemsEventName, itemSelectedEventName,itemMovedEventName,itemResizedEventName,viewChangedEventName, submitEventFunction) {
        this.id = id;
//        TODO what's the difference between using scopeChain variables and object properties (i.e this.id)
        // should have following params: event,view,eventType,eventId,startDate,endDate,dayDelta,minuteDelta,allDay,callback
        this.submitEventFunction = submitEventFunction;
        var elt = document.getElementById(id);
        if (!elt) {
            //TODO handle missing element
            return ;
        }
        var _this = this;
        var isSameDay = function(a,b) {
            if(!a instanceof Date || !b instanceof Date) {
                throw "Both params must be Date objects";
            }
            return a.getYear() == b.getYear()
            && a.getMonth() == b.getMonth()
            && a.getDate() == b.getDate();
        };
        var fillCalendarFunction = function(startDate, endDate, callback) {
            if(options.initialEvents != null){
                var startDateData = options.initialEvents.startDate;
                var endDateData = options.initialEvents.endDate;
                var initialStartDate = new Date(startDateData.year, startDateData.month, startDateData.date);
                var initialEndDate = new Date(endDateData.year, endDateData.month, endDateData.date);
                if(isSameDay(startDate,initialStartDate) && isSameDay(endDate,initialEndDate)) {
                    callback(options.initialEvents.events);
                    return;
                }
            }
            _this.submitEventFunction({} /* stub event */,
                null,
                loadItemsEventName,
                null,
                formatDateParam(startDate),
                formatDateParam(endDate),
                null,null,null,
                function(request, event, data) {
                    if(data != undefined) {
                        callback(data);
                    }
                }
                );
        };
        var eventDrop = function(event,dayDelta,minuteDelta,allDay,revertFunc) {
            _this.submitEventFunction({} /* stub event */,
                null,
                itemMovedEventName,
                event.id,
                null,
                null,
                dayDelta,minuteDelta,allDay,
                function(request, event, data) {
                    if(data != undefined && data!==true) {
                        revertFunc();
                    }
                }
                );
        };
        // TODO support revert
        var eventResize = function(event,dayDelta,minuteDelta,revertFunc) {
            _this.submitEventFunction({} /* stub event */,
                null,
                itemResizedEventName,
                event.id,
                null,
                null,
                dayDelta,minuteDelta,null,
                function(request, event, data) {
                    if(data != undefined && data!==true) {
                        revertFunc();
                    }
                }
                );
        };
        //TODO work on parameters here
        var eventClick = function(event) {
            _this.submitEventFunction({},
                null,
                itemSelectedEventName,
                event.id,
                null,null,null,null,null,null
                );
        };
        var selectedView;
        var viewDisplay = function(view) {
            if(selectedView!=view && selectedView != undefined) {
                _this.submitEventFunction({},
                    view.name,
                    viewChangedEventName,
                    null,null,null,null,null,null,null
                    );
            }
            selectedView = view;
        };
        if(this.submitEventFunction != null) {
            options = jQuery.extend({
                events: fillCalendarFunction,
                eventDrop: eventDrop,
                eventResize: eventResize,
                eventClick: eventClick,
                viewDisplay: viewDisplay
            },options);
        }
        jQuery(document).ready(function() {
            jQuery(elt).fullCalendar(options);
        });
    };

}());
	
	
